From: Simon McVittie <smcv@debian.org>
Date: Fri, 14 Sep 2012 10:23:06 +0100
Subject: Request confirmation if a user enables auto-downloading

The Q3 UI toolkit isn't great at large amounts of text, so just point
to a deb.li link into the Debian wiki.

[Adapted from src:openarena for src:ioquake3]

Origin: vendor, Debian
Bug-Debian: http://bugs.debian.org/686648
---
 code/q3_ui/ui_preferences.c | 38 +++++++++++++++++++++++++++++++++++++-
 1 file changed, 37 insertions(+), 1 deletion(-)

diff --git a/code/q3_ui/ui_preferences.c b/code/q3_ui/ui_preferences.c
index b65728a..58e4c6c 100644
--- a/code/q3_ui/ui_preferences.c
+++ b/code/q3_ui/ui_preferences.c
@@ -103,6 +103,39 @@ static void Preferences_SetMenuItems( void ) {
 	s_preferences.allowdownload.curvalue	= trap_Cvar_VariableValue( "cl_allowDownload" ) != 0;
 }
 
+static void AutoDownloadAction( qboolean result )
+{
+	if (result) {
+		trap_Cvar_SetValue( "cl_allowDownload", 1 );
+	} else {
+		trap_Cvar_SetValue( "cl_allowDownload", 0 );
+	}
+	s_preferences.allowdownload.curvalue = result;
+}
+
+static void UI_ConfirmAutoDownload_Draw ( void )
+{
+	UI_DrawProportionalString( SCREEN_WIDTH/2, 356 + PROP_HEIGHT * 0,
+		"WARNING: This is a security risk.",
+		UI_CENTER|UI_SMALLFONT, color_yellow );
+	UI_DrawProportionalString( SCREEN_WIDTH/2, 356 + PROP_HEIGHT * 1,
+		"More information: <http://deb.li/Q3DL>",
+		UI_CENTER|UI_SMALLFONT, color_yellow );
+}
+
+static void UI_ConfirmAutoDownload( void (*action) (qboolean) )
+{
+	if (trap_Cvar_VariableValue( "cl_allowDownload" ) != 0) {
+		/* already set */
+		return;
+	}
+
+	UI_ConfirmMenu_Style(
+		"Auto-download?",
+		UI_CENTER|UI_SMALLFONT,
+		UI_ConfirmAutoDownload_Draw,
+		action);
+}
 
 static void Preferences_Event( void* ptr, int notification ) {
 	if( notification != QM_ACTIVATED ) {
@@ -154,8 +187,11 @@ static void Preferences_Event( void* ptr, int notification ) {
 		break;
 
 	case ID_ALLOWDOWNLOAD:
-		trap_Cvar_SetValue( "cl_allowDownload", s_preferences.allowdownload.curvalue );
 		trap_Cvar_SetValue( "sv_allowDownload", s_preferences.allowdownload.curvalue );
+		if ( s_preferences.allowdownload.curvalue )
+			UI_ConfirmAutoDownload( AutoDownloadAction );
+		else
+			trap_Cvar_SetValue( "cl_allowDownload", 0 );
 		break;
 
 	case ID_BACK:
